"use strict";

exports.__esModule = true;
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _material = require("@mui/material");
var _ForceDirectedGraph = _interopRequireDefault(require("./ForceDirectedGraph"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var STYLES = {
  popover: {
    pointerEvents: 'none'
  }
};

// TODO: Change height on changing browser window size
var CONTAINER_HEIGHT = window.innerHeight / 2 - 40;
function GraphWithTooltip(_ref) {
  var data = _ref.data,
    nodeCharge = _ref.nodeCharge;
  var _useState = (0, _react.useState)(null),
    anchorEl = _useState[0],
    setAnchorEl = _useState[1];
  var _useState2 = (0, _react.useState)(null),
    hoveredNode = _useState2[0],
    setHoveredNode = _useState2[1];
  var onMouseOverNode = (0, _react.useCallback)(function (data) {
    setHoveredNode(data);
    setAnchorEl(this);
  }, []);
  return /*#__PURE__*/_react["default"].createElement(_material.Box, null, /*#__PURE__*/_react["default"].createElement(_ForceDirectedGraph["default"], {
    data: data,
    containerHeight: CONTAINER_HEIGHT,
    onMouseOverNode: onMouseOverNode,
    onMouseOutNode: function onMouseOutNode() {
      return setAnchorEl(null);
    },
    nodeCharge: nodeCharge
  }), /*#__PURE__*/_react["default"].createElement(_material.Popover, {
    id: "mouse-over-popover",
    sx: STYLES.popover,
    open: Boolean(anchorEl),
    anchorEl: anchorEl,
    onClose: function onClose() {
      return setAnchorEl(null);
    },
    disableRestoreFocus: true,
    anchorOrigin: {
      vertical: 'bottom',
      horizontal: 'center'
    },
    transformOrigin: {
      vertical: 'top',
      horizontal: 'center'
    }
  }, /*#__PURE__*/_react["default"].createElement(_material.TableContainer, null, /*#__PURE__*/_react["default"].createElement(_material.Table, {
    size: "small"
  }, /*#__PURE__*/_react["default"].createElement(_material.TableBody, null, /*#__PURE__*/_react["default"].createElement(_material.TableRow, null, /*#__PURE__*/_react["default"].createElement(_material.TableCell, {
    size: "small"
  }, /*#__PURE__*/_react["default"].createElement("b", null, "Peer ID")), /*#__PURE__*/_react["default"].createElement(_material.TableCell, {
    size: "small"
  }, hoveredNode && hoveredNode.id + " (" + hoveredNode.pseudonym + ")")), /*#__PURE__*/_react["default"].createElement(_material.TableRow, null, /*#__PURE__*/_react["default"].createElement(_material.TableCell, {
    size: "small"
  }, /*#__PURE__*/_react["default"].createElement("b", null, "Multiaddr")), /*#__PURE__*/_react["default"].createElement(_material.TableCell, {
    size: "small"
  }, hoveredNode && hoveredNode.multiaddrs.map(function (multiaddr) {
    return /*#__PURE__*/_react["default"].createElement(_material.Typography, {
      key: multiaddr,
      variant: "body2"
    }, multiaddr);
  }))))))));
}
var _default = GraphWithTooltip;
exports["default"] = _default;
module.exports = exports.default;